using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace Utility
{
    public class AESHelp
    {
        public readonly static string KEY = @"abc12345abc12345abc12345abc12345";
        public readonly static string IV = @"1234567890123456";


        /// AES加密(无向量)
        /// </summary>
        /// <param name="Data">被加密的明文</param>
        /// <param name="Key">密钥</param>
        /// <returns>密文</returns>
        public static string AESEncrypt(String Data, String Key)
        {
            MemoryStream mStream = new MemoryStream();
            RijndaelManaged aes = new RijndaelManaged();

            byte[] plainBytes = Encoding.UTF8.GetBytes(Data);
            Byte[] bKey = new Byte[32];
            Array.Copy(Encoding.UTF8.GetBytes(Key.PadRight(bKey.Length)), bKey, bKey.Length);
            byte[] _iv = Encoding.UTF8.GetBytes(IV);
            aes.Mode = CipherMode.CBC;
            aes.Padding = PaddingMode.PKCS7;
            aes.KeySize = 256;
            //aes.Key = _key;
            aes.Key = bKey;
            aes.IV = _iv;
            CryptoStream cryptoStream = new CryptoStream(mStream, aes.CreateEncryptor(), CryptoStreamMode.Write);
            try
            {
                cryptoStream.Write(plainBytes, 0, plainBytes.Length);
                cryptoStream.FlushFinalBlock();
                return Convert.ToBase64String(mStream.ToArray());
            }
            finally
            {
                cryptoStream.Close();
                mStream.Close();
                aes.Clear();
            }

        }
        /// <summary>
        /// AES解密(无向量)
        /// </summary>
        /// <param name="Data">被加密的明文</param>
        /// <param name="Key">密钥</param>
        /// <returns>明文</returns>
        public static string AESDecrypt(String Data, String Key)
        {
            byte[] inputBytes = Base64StringToByteArray(Data);
            byte[] keyBytes = Encoding.UTF8.GetBytes(Key.Substring(0, 32));
            using (AesCryptoServiceProvider aesAlg = new AesCryptoServiceProvider())
            {
                aesAlg.Key = keyBytes;
                aesAlg.IV = Encoding.UTF8.GetBytes(IV.Substring(0, 16));

                ICryptoTransform decryptor = aesAlg.CreateDecryptor(aesAlg.Key, aesAlg.IV);
                using (MemoryStream msEncrypt = new MemoryStream(inputBytes))
                {
                    using (CryptoStream csEncrypt = new CryptoStream(msEncrypt, decryptor, CryptoStreamMode.Read))
                    {
                        using (StreamReader srEncrypt = new StreamReader(csEncrypt))
                        {
                            string str = srEncrypt.ReadToEnd();
                            srEncrypt.Close();
                            csEncrypt.Close();
                            msEncrypt.Close();
                            return str;
                        }
                    }

                }
            }
        }
        /// <summary>
        /// 将指定的Base64字符串转换为byte数组
        /// </summary>
        /// <param name="s"></param>
        /// <returns>16进制字符串对应的byte数组</returns>
        public static byte[] Base64StringToByteArray(string s)
        {
            byte[] arr = Convert.FromBase64String(s.Substring(s.IndexOf(",") + 1));
            return arr;
        }

        ///// <summary>
        ///// AES 加密
        ///// </summary>
        ///// <param name="input"></param>
        ///// <returns></returns>
        //public static string AESEncrypt(string input)
        //{
        //    if (string.IsNullOrWhiteSpace(input))
        //        return input;

        //    byte[] toEncryptArray = Encoding.UTF8.GetBytes(input);

        //    RijndaelManaged rijndael = new RijndaelManaged();
        //    rijndael.Key = Encoding.UTF8.GetBytes(Key);
        //    rijndael.IV = Encoding.UTF8.GetBytes(IV);
        //    rijndael.Mode = CipherMode.ECB;
        //    rijndael.Padding = PaddingMode.PKCS7;
        //    ICryptoTransform cryptoTransform = rijndael.CreateEncryptor();
        //    byte[] resultArray = cryptoTransform.TransformFinalBlock(toEncryptArray, 0, toEncryptArray.Length);
        //    //return Convert.ToBase64String(resultArray, 0, resultArray.Length);
        //    return ByteArrayToHexString(resultArray);
        //}

        ///// <summary>
        ///// AES 解密
        ///// </summary>
        ///// <param name="input"></param>
        ///// <returns></returns>
        //public static string AESDEncrypt(string input)
        //{
        //    if (string.IsNullOrWhiteSpace(input))
        //        return input;

        //    byte[] keyArray = Encoding.UTF8.GetBytes(Key);
        //    byte[] ivArray = Encoding.UTF8.GetBytes(IV);
        //    byte[] toEncryptArray = HexStringToByteArray(input);

        //    RijndaelManaged rijndael = new RijndaelManaged();
        //    rijndael.Key = keyArray;
        //    rijndael.IV = ivArray;
        //    rijndael.Mode = CipherMode.ECB;
        //    rijndael.Padding = PaddingMode.PKCS7;

        //    ICryptoTransform cryptoTransform = rijndael.CreateDecryptor();
        //    byte[] resultArray = cryptoTransform.TransformFinalBlock(toEncryptArray, 0, toEncryptArray.Length);
        //    return Encoding.UTF8.GetString(resultArray);

        //}

        //public static byte[] HexStringToByteArray(string s)
        //{
        //    s = s.Replace(" ", "");
        //    byte[] buffer = new byte[s.Length / 2];
        //    for (int i = 0; i < s.Length; i += 2)
        //    {
        //        buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
        //    }
        //    return buffer;
        //}

        //public static string ByteArrayToHexString(byte[] data)
        //{
        //    StringBuilder sb = new StringBuilder(data.Length * 3);
        //    foreach (byte b in data)
        //    {
        //        sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
        //    }
        //    return sb.ToString().ToUpper();
        //}


        public static void TestAES()
        {
            //JsonConvert.SerializeObject()

            //string s = AESEncrypt("我我我我xxx1111....");

            //Console.WriteLine(s);
            //Console.WriteLine(AESDEncrypt(s));

            //bool bool1 = true;
            //bool bool2 = true;
            //bool bool3 = false;
            //bool bool4 = false;
            //Console.WriteLine("bool1 & bool2 :" + (bool1 & bool2));
            //Console.WriteLine("bool3 & bool4 :" + (bool3 & bool4));
            //Console.WriteLine("bool1 & bool3 :" + (bool1 & bool3));

            //Console.Read();
        }
    }
}
